<template>
    <div :class="{ 'ishopet-slider-effect slider-arrows' : addons.includes('ishopet') }">
        <VueSlickCarousel v-bind="slick_settings" :rtl="settings.text_direction == 'rtl'" ref="carousel_best" @reInit="swipeSlide">
            <div v-for="(product,index) in products" :key="index" class="padding_17" :class="{ 'ishopet-pr-0' : addons.includes('ishopet') }">
              <div class="sg-product slider_div" :class="{ 'style-1' : type == 'flash', 'ishopet-sg-product' : addons.includes('ishopet') }">
                <a :href="'product/'+product.slug" @click.prevent="routerNavigator('product.details',product.slug)">
                    <div class="product-thumb">
                        <div class="span_container" style="min-height: 40px !important;">
                            <span>
                              <span class="base new">New</span>
                              <span class="base reword-badge" v-if="addons.includes('reward') && product.reward > 0">
                                Reward: {{ product.reward }}
                              </span>
                            </span>
                            <span v-if="authUser">
                              <span class="favorite_span" v-if="$store.getters.isThisWishlisted(product.id)">
                                  <a href="javaScript:void(0)" @click="removeWishlist(product.id)">
                                      <span class="mdi mdi-name mdi-heart"></span>
                                  </a>
                              </span>
                              <span class="favorite_span" v-else>
                                  <a href="javaScript:void(0)" :class="{ 'disable_btn' :  is_disabled == true }" @click="addToWishlist(product.id)">
                                      <span class="mdi mdi-name mdi-heart-outline"></span>
                                  </a>
                              </span>
                            </span>
                          <!-- <span class="base" v-if="product.special_discount_check > 0">{{
                            product.special_discount_type == 'flat' ? priceFormat(product.special_discount_check) + ' '+lang.off : product.special_discount_check + '% '+lang.off
                          }} 
                          </span> -->
                          <!-- <span v-if="product.current_stock == 0 && !product.is_classified" class="base stock_badge">{{
                            lang.out_of_stock
                          }}
                          </span> -->
                        </div>
                        <img :src="product.image_190x230" :alt="product.product_name" class="img-fluid">
                    </div>
                </a>
                <div class="product-info">
                    <h1 class="product-name text-ellipse-one" :title="product.product_name ">
                        <a :href="'product/'+product.slug"
                          @click.prevent="routerNavigator('product.details',product.slug)">
                          {{ product.product_name }}
                        </a>
                    </h1>
                    <span class="price">
						<div v-if="product.special_discount_check > 0">
							<span>
							  {{ priceFormat(product.discount_percentage) }}
							</span>
							<div class="discount_style">
								<del>{{ priceFormat(product.price) }} </del>
								<span class="base discount">
									{{ product.special_discount_type == 'flat' ? priceFormat(product.special_discount_check) + ' '+lang.off : product.special_discount_check + '% '+lang.off }} 
								</span>
							</div>
						</div>
                      	<span v-else>{{ priceFormat(product.price) }}</span>
                    </span>
					<!-- <span class="base discount" v-if="product.special_discount_check > 0">
						{{ product.special_discount_type == 'flat' ? priceFormat(product.special_discount_check) + ' '+lang.off : product.special_discount_check + '% '+lang.off }} 
                    </span> -->
                  <!-- <div class="sg-rating" v-if="!addons.includes('ishopet')">
                    <star-rating v-model:rating="product.rating" :read-only="true" :star-size="12" :round-start-rating="false"></star-rating>
                    <span class="reviews" v-if="product.reviews_count > 0">({{
                        product.reviews_count
                      }} {{ lang.reviews }})</span>
                  </div> -->
                  <div class="icons">
                      <div class="inner_icon_container">
                        <div class="sg-rating" v-if="!addons.includes('ishopet') && product.reviews_count > 0">
                          <!-- <star-rating v-model:rating="product.rating" :read-only="true" :star-size="12" :round-start-rating="false"></star-rating> -->
                          <div style="display:flex !important;flex-direction: row-reverse !important;gap:6px !important" class="rev" v-if="product.reviews_count > 0">
                          <div><span>({{product.reviews_count}} reviews)</span></div>
                          <div class="rat_father" style="background-color:#E6D7DA !important;display:flex !important;align-items:baseline !important;border-radius:7px !important">
                            <div class="starrr"></div>
                            <span class="rat_num" style="font-size:14px !important">{{ product.rating }}</span>
                          </div>
                          </div>
                        </div>
                        <ul class="global-list">
                          <!-- <li v-if="product.minimum_order_quantity <= product.current_stock && !product.is_catalog && !product.is_classified"><a
                            href="javaScript:void(0)" @click="cartBtn(product,index)"><span
                            class="mdi mdi-name mdi-shopping-outline">
                            <Bag/></span></a>
                          </li> -->
                          <li><a href="javaScript:void(0)" @click="productFetch(product.slug)"><span
                            class="mdi mdi-name mdi-magnify">
                          <Search/></span></a></li>
                          
                          <!-- <li v-if="compareCheck(product)"><a class="active_compare"
                                            :class="{ 'disable_btn' :  is_disabled == true }"
                                            @click="removeCompare(product.id)"
                                            href="javaScript:void(0)"><span
                            class="mdi mdi-name mdi-scale-balance"></span></a></li>
                          <li v-else><a @click="addToCompare(product)"
                                :class="{ 'disable_btn' :  is_disabled == true }"
                                href="javaScript:void(0)"><span
                            class="mdi mdi-name mdi-scale-balance"></span></a></li>
                          -->
                          <li v-if="product.minimum_order_quantity <= product.current_stock && !product.is_catalog && !product.is_classified"><a
                            href="javaScript:void(0)" @click="cartBtn(product,index)"><span
                            class="mdi mdi-name mdi-shopping-outline">
                            <Bag/></span></a>
                          </li>
                        </ul>
                    </div>
                  </div>
                </div>
              </div>
            </div>
        </VueSlickCarousel>
    </div>
</template>

<script>
import StarRating from 'vue-star-rating';
import FlipCountdown from "vue2-flip-countdown";
import shimmer from "../partials/shimmer";
import detailsView from "../partials/details-view";
import VueSlickCarousel from 'vue-slick-carousel'
import Bag from '../homepage/Bag.vue'
import Search from '../homepage/Search.vue'

export default {
  name: "product",
  props: [
    'products',
    'grid_class',
    'type',
    'number',
  ],
  components: {
    FlipCountdown, StarRating,
    shimmer, detailsView, VueSlickCarousel, Bag, Search
  },
  data() {
    return {
      checkListing: true,
      showModal: false,
      currentSlide: 0,
      is_disabled: false,
      slick_settings: {
        dots: false,
        infinite: true,
        speed: 500,
        touchThreshold: 5,
        slidesToShow: 3,
        slidesToScroll: 1,
        initialSlide: 0,
        arrows: true,
        autoplay: true,
        autoplaySpeed: 0,
        responsive: [
          // {
          //   breakpoint: 1024,
          //   settings: {
          //     slidesToShow: 3,
          //     slidesToScroll: 3,
          //     infinite: false,
          //     dots: false
          //   }
          // },
          {
            breakpoint: 991,
            settings: {
              slidesToShow: 2,
              slidesToScroll: 1,
              infinite: false,
              dots: false
            }
          },
          // {
          //   breakpoint: 768,
          //   settings: {
          //     slidesToShow: 2,
          //     slidesToScroll: 1,
          //     initialSlide: 2
          //   }
          // },
          {
            breakpoint: 660,
            settings: {
              slidesToShow: 1.5,
              slidesToScroll: 1
            }
          },
          // {
          //   breakpoint: 575,
          //   settings: {
          //     slidesToShow: 2,
          //     slidesToScroll: 1
          //   }
          // },
           {
            breakpoint: 480,
            settings: {
              slidesToShow: 1,
              slidesToScroll: 1
            }
          },
          {

            breakpoint: 390,
            settings: {
              slidesToShow: 1,
              slidesToScroll: 1
            }
          }
        ]
      }
    }
  },

  mounted() {
    if (this.authUser) {
      setTimeout(() => this.pushWishlists(), 2000);
    }
    this.compareList();
  },
  computed: {
    activeCurrency() {
      return this.$store.getters.getActiveCurrency;
    },
    wishlists() {
      return this.$store.getters.getUserWishlist;
    },
    compareLists() {
      return this.$store.getters.getUserCompare;
    },
    count_compare() {
      return this.$store.getters.getCountCompare;
    },

    productDetails() {
      let products = this.$store.getters.getProductDetails;
      for (let i = 0; i < products.length; i++) {
        if (products[i].slug == this.active_modal) {
          return products[i].product;
        }
      }
      return false;
    }
  },

  methods: {
    addToWishlist(id) {
      this.is_disabled = true
      this.$store.commit('addNewWishlistId',id);
      let url = this.getUrl('user/add-to-wishlist/' + id);
      axios.get(url).then((response) => {
        this.is_disabled = false
        if (response.data.error) {
          this.$Progress.error();
          toastr.error(response.data.error, this.lang.Error + ' !!');
        } else {
          this.$store.dispatch('userWishlistProduct', response.data.wishlist);
          this.$store.dispatch('wishlists', response.data.wishlists);
          toastr.success(response.data.success, this.lang.Success + ' !!');
        }
      });
    },
    compareCheck(product) {
      let length = Object.keys(this.compareLists).length;

      for (let i = 0; i < length; i++) {
        if (product.id == this.compareLists[i].id) {
          return true;
        }
      }
      return false;
    },
    removeWishlist(id) {

      this.checkListing = false;
      this.$store.commit('removeFromWishlistID',id);

      let url = this.getUrl('user/remove-wishlist-product/' + id);
      axios.get(url).then((response) => {
        if (response.data.error) {
          this.$Progress.fail();
          toastr.error(response.data.error, this.lang.Error + ' !!');
        } else {
          this.checkListing = true;
          this.$store.commit('getRemoveWishlist', response.data.wishlist);
          this.$store.dispatch('wishlists', response.data.totalWishlist);
          toastr.success(response.data.success, this.lang.Success + ' !!');
        }
      });

    },
    pushWishlists() {
      if (this.wishlists.length > 0) {
        let length = Object.keys(this.wishlists).length;

        if (length == 0) {
          let product_length = this.products.length;
          for (let i = 0; i < product_length; i++) {
            let wishlist = this.products[i].user_wishlist;
            if (wishlist) {
              this.$store.dispatch('userWishlistProduct', wishlist);
            }
          }
        }
      }
    },
    compareList() {
      let length = this.compareLists.length;
      let flag = this.count_compare;

      if (length == 0 && flag) {
        this.$store.commit('getCountCompare', false);
        let url = this.getUrl('home/compare-list');
        axios.get(url).then((response) => {
          if (response.data.error) {
            toastr.error(response.data.error, this.lang.Error + ' !!');
          } else {
            let products = response.data.products;
            for (let i = 0; i < products.length; i++) {
              let compare = products[i];
              if (compare) {
                this.$store.dispatch('userCompareProduct', compare);
              }
            }
            // this.pushCompare();
          }
        });
      }
    },
    addToCompare(product) {
      this.is_disabled = true;
      let url = this.getUrl('home/add-to-compare/' + product.id);
      axios.get(url).then((response) => {
        this.is_disabled = false;
        if (response.data.error) {
          toastr.error(response.data.error, this.lang.Error + ' !!');
        } else {
          this.$store.commit('getUserCompare', response.data.product);
          this.$store.dispatch('compareList', response.data.compare_list);
        }
      });
    },
    removeCompare(id) {
      let url = this.getUrl('home/remove-compare_product/' + id);
      axios.get(url).then((response) => {
        if (response.data.error) {
          toastr.error(response.data.error, this.lang.Error + ' !!');
        } else {
          this.$store.commit('getRemoveCompare', response.data.product);
          this.$store.dispatch('compareList', response.data.compare_list);
        }
      });
    },
    pageChange(i) {
      this.currentSlide = i;
    },
    swipeSlide() {
      setTimeout(() => {
        if(this.$refs.carousel_best)
        {
          this.$refs.carousel_best.pause();
        }
      },1000);
    },
    swipe(event) {
      if (event == 'left') {
        this.$refs.carousel_best.next();
      } else if(event == 'right') {
        this.$refs.carousel_best.prev();
      }
    }
  }
}

</script>
<style scoped>
.rev{
  display:flex !important;
  flex-direction: row-reverse !important;
  gap:6px !important;
  align-items: center !important;
}
.rat_father{
	background-color:#F4EADE !important;
	display:flex !important;
	align-items:center !important;
	border-radius:7px !important;
	/* width: 70px; */
	justify-content:center !important;
    gap: 3px;
}
.rat_num{
  font-size:18px !important
}
.ccc {
	margin: 20px;
	display:flex;
	width: 150px;
	height: 150px;
  	flex-wrap: wrap;
	gap: 10px;
}

.starrr {
	width: 22px;
	height: 22px;
	background: #66101F;
	clip-path: polygon(50% 5%, 61% 40%, 98% 40%, 68% 62%, 79% 96%, 50% 75%, 21% 96%, 32% 62%, 2% 40%, 39% 40%);
}
.sg-product{
  min-height: 476px!important;
}
@media(max-width:1199px){
  .sg-product{
    padding:6px
  }
}
@media(max-width:991px){
  .product-thumb{
    padding:7px;
  }
}
</style>
